\documentclass[14pt,xcolor=dvipsnames,presentation,aspectratio=169]{beamer}
\usepackage[utf8]{inputenc}

% Font
%\usepackage[default]{lato}
%\usepackage{helvet}
%\usepackage[default]{cantarell}
%\usepackage[sfdefault]{biolinum}
%\usepackage{cmbright}
\usepackage[sfdefault,lf]{carlito}
\renewcommand*\oldstylenums[1]{\carlitoOsF #1}


\usepackage[T1]{fontenc}
\usepackage{fixltx2e}
\usepackage{graphicx}
\usepackage{grffile}
\usepackage{longtable}
\usepackage[export]{adjustbox}[2011/08/13]
\usepackage{wrapfig}
\usepackage{rotating}
\usepackage[normalem]{ulem}
\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{amssymb}
\usepackage{capt-of}
\usepackage{hyperref}
\usedescriptionitemofwidthas{bl}
\usepackage{ifthen,figlatex,amsmath,amstext,xspace}
\usepackage{boxedminipage,xspace,multicol}
\usepackage{subfigure}
\usepackage{algorithm2e}
\usepackage{hhline}
\usepackage{multirow}
\usepackage{booktabs}

%\usetheme{Madrid}
%\usecolortheme[named=BrickRed]{structure}

\useoutertheme{default}
\useinnertheme{default}

\setbeamercolor*{frametitle}{fg=orange,bg=white}
\setbeamercolor*{lower separation line head}{bg=DeepSkyBlue4} 
\setbeamercolor*{normal text}{fg=black,bg=white} 
\setbeamercolor*{alerted text}{fg=red} 
\setbeamercolor*{example text}{fg=black} 
%\setbeamercolor*{structure}{fg=black} 
% 
\setbeamercolor*{palette tertiary}{fg=black,bg=black!10} 
\setbeamercolor*{palette quaternary}{fg=black,bg=black!10} 
%
\definecolor{my-light-blue}{HTML}{D3DCEC}
\definecolor{my-dark-blue}{HTML}{093A7A}
\definecolor{my-dark-blue2}{HTML}{00688B}
\definecolor{my-light-red}{HTML}{FFBABA}
\definecolor{my-dark-red}{HTML}{D51111}
%\definecolor{my-light-orange}{HTML}{F2B76E}
\definecolor{my-light-orange}{HTML}{FFD8B2}
%\definecolor{my-dark-orange}{HTML}{FFA500}
%\definecolor{my-dark-orange}{HTML}{CF7C00}
\definecolor{my-dark-orange}{HTML}{FE8D00}
\definecolor{my-light-green}{HTML}{BFFFBF}
\definecolor{my-dark-green}{HTML}{00B000}
\definecolor{my-light-grey}{HTML}{E6E6E6}

\setbeamertemplate{blocks}[rounded]
\setbeamercolor{block body}{bg=my-light-orange}
\setbeamercolor{block title}{bg=my-dark-orange,fg=white}
\setbeamercolor{block body alerted}{bg=my-light-red}
\setbeamercolor{block title alerted}{bg=my-dark-red,fg=white}
\setbeamercolor{block body example}{bg=my-light-green}
\setbeamercolor{block title example}{bg=my-dark-green,fg=white}

\setbeamertemplate{footline}[frame number]
\setbeamertemplate{navigation symbols}{}

% \usepackage[colorlinks=true,citecolor=pdfcitecolor,urlcolor=pdfurlcolor,linkcolor=pdflinkcolor,pdfborder={0 0 0}]{hyperref}

\usepackage[round-precision=3,round-mode=figures,scientific-notation=true]{siunitx}
\usetheme{default}
\date{13 September 2023}
\title{Introduction to deployment}
\hypersetup{
 pdfauthor={Baptiste Jonglez},
 pdftitle={Introduction to deployment},
 pdfkeywords={},
 pdfsubject={},
 pdfcreator={},
 pdflang={English}}


\begin{document}

\urlstyle{sf}
\let\alert=\structure
\let\epsilon=\varepsilon
\let\leq=\leqslant
\let\geq=\geqslant


\author{Baptiste Jonglez, Inria}

\maketitle

\begin{frame}{DevOps chain}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-all.png}
\end{figure}

\vspace{1cm}

\textbf{Adopting DevOps = designing an automated toolchain}
\end{frame}

\begin{frame}{DevOps chain: dev/test}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-dev.png}
\end{figure}

\vspace{1cm}

\textbf{Example tools for dev/test:} Git, Gitlab, Gitlab-CI, code quality tools, automated testing
\end{frame}

\begin{frame}{DevOps chain: build}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-build.png}
\end{figure}

\vspace{1cm}

\textbf{Example tools for build:} Docker, Packer, Kameleon, Nix, Guix\\\textit{We covered this during the morning}

\vspace{1cm}

\textbf{Sub-category:} binary artifact repositories (Docker hub, Gitlab container registry, Zenodo, a web server, your laptop...)
\end{frame}

\begin{frame}{DevOps chain: deploy (1)}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-deploy.png}
\end{figure}

\vspace{1cm}

\textbf{Deploy:} configure some \textbf{resources} to reach a
\textbf{desired state} allowing to run the application

\vspace{1cm}

\textbf{Example tools for deploy:} Ansible, Puppet, Juju, GitOps tools...
\end{frame}

\begin{frame}{DevOps chain: deploy (2)}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-deploy.png}
\end{figure}

\vspace{1cm}

What are \textbf{resources}? \textbf{They provide the underlying infrastructure!}

\vspace{1cm}

Examples: virtual machines or bare-metal machines?  How many machines?
How much RAM and disk do I need?  A GPU maybe?  Network connectivity
between machines?  Do I need a managed database or load balancer?
Serverless functions?
\end{frame}

\begin{frame}{DevOps chain: provision}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-provision.png}
\end{figure}

\vspace{1cm}

\textbf{Provision:} create the necessary infrastructure resources and make
them usable for deploy

\vspace{1cm}

\textbf{Example tools for provision:} Terraform, Ansible (client-side), OpenStack, CloudStack, Proxmox, OpenNebula (infrastructure-side)
\end{frame}

\begin{frame}{DevOps chain: run}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-run.png}
\end{figure}

\vspace{1cm}

\textbf{Run:} monitor and maintain the running applications

\vspace{1cm}

\textbf{Example tools for run:} Kubernetes, Nomad (orchestration), Docker-compose, all monitoring tools
\end{frame}

\begin{frame}{Example DevOps chain (1)}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-all.png}
\end{figure}

Infrastructure of \textbf{Deuxfleurs}, a non-profit CHATONS hosting provider (code at \url{https://git.deuxfleurs.fr/Deuxfleurs/nixcfg})
\begin{itemize}
\item \textbf{Build} (old): Gitea + Drone CI + Dockerfile + Docker hub
\item \textbf{Build} (new): Gitea + Drone CI + Nix
\item \textbf{Provision:} bare metal servers installed with NixOS $\rightarrow$ \textit{not automated}
\item \textbf{Deploy:} SSH-based scripts to deploy Nomad, then Nomad to deploy applications $\rightarrow$ \textit{not triggered automatically}
\item \textbf{Run:} Nomad orchestrator with Nix2 or Docker driver + Consul for storing configuration
\end{itemize}
\end{frame}

\begin{frame}{Example DevOps chain (2)}
\begin{figure}
  \centering
  \includegraphics[width=\textwidth]{figures/devops-chain-all.png}
\end{figure}

\vspace{0.5cm}
\textbf{Overleaf instance} maintained by SED at \url{https://overleaf.irisa.fr}:
\begin{itemize}
\item \textbf{Build:} Gitlab-CI + Gitlab container registry
\item \textbf{Provision:} asking nicely some VMs to Inria DSI (IT team) $\rightarrow$ \textit{not automated}
\item \textbf{Deploy:} Ansible to configure VMs and create docker-compose configuration $\rightarrow$ \textit{not triggered automatically}
\item \textbf{Run:} Docker-compose on Debian
\end{itemize}
\end{frame}

\begin{frame}{Demo time}
Next:
\begin{itemize}
\item Matthieu and Guillermo will present their work on \textbf{deploying Overleaf}
\item \textbf{Terraform} demo (well-known automated provisioning tool)
\item \textbf{Enoslib} demo (provisioning + deploy tool for experimental research)
\end{itemize}
\end{frame}

\end{document}
